program printing
    
  use mtime
  use mo_kind , only: i8

  implicit none

  call setCalendar(proleptic_gregorian)

  call testDatetimePrint('2003-12-31T12:00:00')
  call testDatetimePrint('2004-01-01T00:00:00')

  call testTimedeltaPrint('PT12H')
  call testTimedeltaPrint('PT06H')
  call testTimedeltaPrint('PT6H')
  call testTimedeltaPrint('PT2M')
  call testTimedeltaPrint('PT01H')
  call testTimedeltaPrint('P01M')
  call testTimedeltaPrint('P2M')
  call testTimedeltaPrint('PT10S')
  call testTimedeltaPrint('PT1S')
  call testTimedeltaPrint('PT100S')
  call testTimedeltaPrint('PT100.5S')
  call testTimedeltaPrint('PT934565S')
  call testTimedeltaPrint('P02DT06H')
  call testTimedeltaPrint('P2DT6H')
  call testTimedeltaPrint('P200D')

contains


  subroutine testTimeDeltaPrint(timeDelta_string)

    character(len=*), intent(in) :: timeDelta_string

    type(timedelta), pointer :: td

    td => newTimedelta(timeDelta_string)
    call print_mtime('printing','testTimeDeltaPrint:',td)
    call deallocateTimeDelta(td)
  end subroutine testTimeDeltaPrint

  subroutine testDatetimePrint(datetime_string)

    character(len=*), intent(in) :: datetime_string

    type(datetime), pointer :: dt

    dt => newDatetime(datetime_string)
    call print_mtime('printing','testDatetimePrint:',dt)
    call deallocateDatetime(dt)
  end subroutine testDatetimePrint

end program printing
